import { Stream, Listener, Subscription } from 'xstream'
import { PushEvent } from './baseTypes'
export { Listener, Subscription }
export interface UseEvent {
    (eventName: string): [Stream<void>, () => any]
    <T = any>(eventName: string, seedValue?: T): [Stream<T>, (val: T) => any]
}
export interface FromEvent {
    (eventName: string): Stream<void>
    <T>(eventName: string, valueTransformer?: (val: any) => T): Stream<T>
}
export interface ObservableComponentBase {
    mount: Stream<any>
    unmount: Stream<any>
    fromEvent: FromEvent
    pushEvent: PushEvent
    useEvent: UseEvent
}
export interface Observe {
    observe: <T>(
        propName?: string,
        valueTransformer?: (val: any) => T
    ) => Stream<T>
}
export declare type ObservableComponent = Observe & ObservableComponentBase
export declare type Aperture<P, E, C = any> = (
    component: ObservableComponent,
    initialProps: P,
    initialContext?: C
) => Stream<E>
export declare const subscribeToSink: <T>(
    sink: Stream<T>,
    next: (val: T) => void,
    error?: (error: any) => void
) => Subscription
export declare const getObserve: <P>(
    getProp: any,
    data: any,
    decoratedProps: any
) => <T>(propName?: any, valueTransformer?: any) => any
export declare const createComponent: <P>(
    getProp: any,
    dataObservable: any,
    pushEvent: PushEvent,
    decoratedProps: boolean
) => ObservableComponent
export declare const createObservable: (
    subscribe: any
) => {
    [x: string]: any
    subscribe: any
}
